uniform float	uniFogFactor,			//	0.0 = off;  1.0 = on
				uniFogRangeParameter;	//	hyperbolic interpretation:  1 / (cosh(max_r) - 1)

attribute mat4	atrModelViewProjectionMatrix,
				atrModelViewMatrix;
attribute vec4	atrPosition;
attribute vec2	atrTextureCoordinates;
attribute vec4	atrColor;

varying vec2	varTextureCoordinates;
varying vec4	varColor;


void main()
{
	float	tmpW,			//	vertex's w-coordinate in eye coordinates
			tmpFogValue;	//	0.0 = bright;  1.0 = dark
	
	gl_Position = atrModelViewProjectionMatrix * atrPosition;

	varTextureCoordinates = atrTextureCoordinates;

	//	Let the fog be proportional to
	//
	//		log(w) = log(cosh(d)) ≈ log(exp(d)/2) = d - log(2)
	//
	tmpW		= dot(atrModelViewMatrix[3], atrPosition);
	tmpFogValue	= uniFogRangeParameter * log(tmpW);
	varColor	= (1.0 - uniFogFactor*tmpFogValue) * atrColor;
}
